package com.magicrf.uhfreader;

import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.Button;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import android.widget.TextView;
import android.widget.Toast;
import android.zyapi.CommonApi;

import com.android.hdhe.uhf.reader.R;
import com.qs.uhf.uhfreaderlib.reader.EPC;
import com.qs.uhf.uhfreaderlib.reader.Tools;
import com.qs.uhf.uhfreaderlib.reader.UhfReader;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class MainActivity extends Activity implements OnClickListener,
        OnItemClickListener {

    private Button buttonClear;
    private Button buttonConnect;
    private static Button buttonStart;
    private Button button1;
    private TextView textVersion;
    private ListView listViewData;
    private ArrayList<EPC> listEPC;
    private ArrayList<Map<String, Object>> listMap;
    private boolean runFlag = true;
    public static boolean startFlag = false;//是否开启盘存
    private boolean connectFlag = false;
    private boolean powerOn = false;
    private static String serialPortPath = "/dev/ttyS1";
    public static UhfReader reader; // 超高频读写器
    private UhfReaderDevice readerDevice; // 读写器设备，抓哟操作读写器电源

    private ScreenStateReceiver screenReceiver;
    static CommonApi mCommonApi;
    private static int mComFd = -1;
    MediaPlayer player;
    private GetMessageBroadcastReceiver getMessageBroadcastReceiver;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
//		setOverflowShowingAlways();
        setContentView(R.layout.main);

        initView();

//        openPrintUtils();//开启打印

        serialPortPath = "/dev/ttyMT0";

        mCommonApi = new CommonApi();

        openGPIO();

        mComFd = mCommonApi.openCom(serialPortPath, 115200, 8, 'N', 1);


        new Handler().postDelayed(new Runnable() {
            @Override
            public void run() {

                byte[] bt1 = new byte[]{(byte) 0xaa, (byte) 0xaa, (byte) 0xaa, 0x0a};

                mCommonApi.writeCom(mComFd, bt1, bt1.length);

                mCommonApi.closeCom(mComFd);
            }
        }, 200);

        new Handler().postDelayed(new Runnable() {
            @Override
            public void run() {

                UhfReader.setPortPath(serialPortPath);

                reader = UhfReader.getInstance();

                if(reader==null){
                    Toast.makeText(getApplicationContext(),"无法打开串口 Cannot open port",Toast.LENGTH_SHORT).show();
                    return;
                }
                //设为欧洲频段
                reader.setWorkArea(03);

                // 获取读写器设备示例，若返回null，则设备电源打开失败
                readerDevice = UhfReaderDevice.getInstance();
                if (reader == null) {
                    textVersion.setText("serialport init fail");
                    setButtonClickable(buttonClear, false);
                    setButtonClickable(buttonStart, false);
                    setButtonClickable(buttonConnect, false);
                    return;
                }
                if (readerDevice == null) {
                    textVersion.setText("UHF reader power on failed");
                    setButtonClickable(buttonClear, false);
                    setButtonClickable(buttonStart, false);
                    setButtonClickable(buttonConnect, false);
                    return;
                }

                // 获取用户设置功率,并设置
                SharedPreferences shared = getSharedPreferences("power", 0);
                int value = shared.getInt("value", 26);
                Log.d("", "value" + value);
                reader.setOutputPower(value);

                setButtonClickable(buttonConnect, true);

            }
        }, 1500);

        // 初始化声音播放器
        player = MediaPlayer.create(this, R.raw.msg);

        button1 = (Button) findViewById(R.id.button1);
        button1.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                // TODO Auto-generated method stub
//                PrintUtils.printQRCode(1, 300, 300, "1123456790a", true, 25, false);
            }
        });

        Thread thread = new InventoryThread();
        thread.start();

    }


    private void openPrintUtils() {

        PrintUtils.initPrintUtils(this);//打印的初始化

        new Handler().postDelayed(new Runnable() {
            @Override
            public void run() {
                // TODO Auto-generated method stub
//                // 开启标签打印模式
                PrintUtils.send(new byte[]{0x1F, 0x1B, 0x1F, (byte) 0x80, 0x04,
                        0x05, 0x06, 0x44});

                // 黑标起始位设置，倒数第二个字节0x30为标签起始位
                PrintUtils.send(new byte[]{0x1D, 0x28, 0x46, 0x04, 0x00, 0x01, 0x00,
                        0x30, 0x00});

            }
        }, 2500);

        getMessageBroadcastReceiver = new GetMessageBroadcastReceiver();
        IntentFilter intentFilter_getMessage = new IntentFilter();
        intentFilter_getMessage.addAction("com.qs.getmassage");
        this.registerReceiver(getMessageBroadcastReceiver, intentFilter_getMessage);

    }

    // 打开gpio
    public static void openGPIO() {
        // TODO Auto-generated method stub

        mCommonApi.setGpioDir(17, 1);
        mCommonApi.setGpioOut(17, 1);

        mCommonApi.setGpioDir(25, 1);
        mCommonApi.setGpioOut(25, 1);

        mCommonApi.setGpioDir(26, 1);
        mCommonApi.setGpioOut(26, 1);

        buttonStart.setText(R.string.inventory);

    }

    // 关闭gpio
    public static void closeGPIO() {

        mCommonApi.setGpioDir(17, 1);
        mCommonApi.setGpioOut(17, 0);

//        mCommonApi.setGpioDir(25, 1);
//        mCommonApi.setGpioOut(25, 0);

        mCommonApi.setGpioDir(26, 1);
        mCommonApi.setGpioOut(26, 0);

    }

    private void initView() {

        buttonStart = (Button) findViewById(R.id.button_start);
        buttonConnect = (Button) findViewById(R.id.button_connect);
        buttonClear = (Button) findViewById(R.id.button_clear);
        listViewData = (ListView) findViewById(R.id.listView_data);
        textVersion = (TextView) findViewById(R.id.textView_version);
        buttonStart.setOnClickListener(this);
        buttonConnect.setOnClickListener(this);
        buttonClear.setOnClickListener(this);
        setButtonClickable(buttonStart, true);
        setButtonClickable(buttonConnect, false);
        listEPC = new ArrayList<EPC>();
        listViewData.setOnItemClickListener(this);

    }

    /**
     * 盘存线程
     *
     * @author Administrator
     */
    class InventoryThread extends Thread {
        private List<byte[]> epcList;

        @Override
        public void run() {
            super.run();
            while (runFlag) {
                if (startFlag) {
                    epcList = reader.inventoryRealTime(); // 实时盘存
                    if (epcList != null && !epcList.isEmpty()) {
                        // 播放提示音
                        player.start();
                        for (byte[] epc : epcList) {
                            if (epc != null) {
                                String epcStr = Tools.Bytes2HexString(epc,
                                        epc.length);
                                Log.e("run: ", epcStr);
                                addToList(listEPC, epcStr);
                            }
                        }
                    }
                    epcList = null;
                    try {
                        Thread.sleep(40);
                    } catch (InterruptedException e) {
                        // TODO Auto-generated catch block
                        e.printStackTrace();
                    }
                }
            }
        }
    }

    // 将读取的EPC添加到LISTVIEW
    private void addToList(final List<EPC> list, final String epc) {
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                // 第一次读入数据
                if (list.isEmpty()) {
                    EPC epcTag = new EPC();
                    epcTag.setEpc(epc);
                    epcTag.setCount(1);
                    list.add(epcTag);
                } else {
                    for (int i = 0; i < list.size(); i++) {
                        EPC mEPC = list.get(i);
                        // list中有此EPC
                        if (epc.equals(mEPC.getEpc())) {
                            mEPC.setCount(mEPC.getCount() + 1);
                            list.set(i, mEPC);
                            break;
                        } else if (i == (list.size() - 1)) {
                            // list中没有此epc
                            EPC newEPC = new EPC();
                            newEPC.setEpc(epc);
                            newEPC.setCount(1);
                            list.add(newEPC);
                        }
                    }
                }
                // 将数据添加到ListView
                listMap = new ArrayList<Map<String, Object>>();
                int idcount = 1;
                for (EPC epcdata : list) {
                    Map<String, Object> map = new HashMap<String, Object>();
                    Log.e("EPC: ", epcdata.getEpc());
                    map.put("ID", idcount);
                    map.put("EPC", epcdata.getEpc());
                    map.put("COUNT", epcdata.getCount());
                    idcount++;
                    listMap.add(map);
                }
                listViewData.setAdapter(new SimpleAdapter(MainActivity.this,
                        listMap, R.layout.listview_item, new String[]{"ID",
                        "EPC", "COUNT"}, new int[]{R.id.textView_id,
                        R.id.textView_epc, R.id.textView_count}));
            }
        });
    }

    // 设置按钮是否可用
    private void setButtonClickable(Button button, boolean flag) {
        button.setClickable(flag);
        if (flag) {
            button.setTextColor(Color.BLACK);
        } else {
            button.setTextColor(Color.GRAY);
        }
    }

    @Override
    public void onBackPressed() {
        runFlag = false;
        startFlag = false;
        reader.close();
        if (getMessageBroadcastReceiver != null) {
            unregisterReceiver(getMessageBroadcastReceiver);
        }

        closeGPIO();
        mComFd = mCommonApi.openCom(serialPortPath, 115200, 8, 'N', 1);
        byte[] bt1 = new byte[]{(byte) 0xaa, (byte) 0xaa, (byte) 0xaa, 0x0b};

        mCommonApi.writeCom(mComFd, bt1, bt1.length);
        mCommonApi.closeCom(mComFd);

        System.exit(0);
        super.onBackPressed();
    }

    @Override
    protected void onDestroy() {

        Log.e("销毁界面", "销毁界面");
        super.onDestroy();
    }

    /**
     * 清空listview
     */
    private void clearData() {
        listEPC.removeAll(listEPC);
        listViewData.setAdapter(null);
    }

    @Override
    public void onClick(View v) {

        switch (v.getId()) {
            case R.id.button_start://开始盘存和关闭存盘
                if (!startFlag) {
                    startFlag = true;
                    buttonStart.setText(R.string.stop_inventory);
                } else {
                    startFlag = false;
                    buttonStart.setText(R.string.inventory);
                }
                break;
            case R.id.button_connect:

                byte[] versionBytes = reader.getFirmware();
                if (versionBytes != null) {
                    // reader.setWorkArea(3);//设置成欧标
                    player.start();
                    // String version = new String(versionBytes);
                    // textVersion.setText(new String(versionBytes));
                    setButtonClickable(buttonConnect, false);
                    setButtonClickable(buttonStart, true);
                }
                setButtonClickable(buttonConnect, false);
                setButtonClickable(buttonStart, true);
                break;

            case R.id.button_clear:
                clearData();
                break;
            default:
                break;

        }
    }

    @Override
    public void onItemClick(AdapterView<?> adapter, View view, int position,
                            long id) {
        TextView epcTextview = (TextView) view.findViewById(R.id.textView_epc);
        String epc = epcTextview.getText().toString();
        // 选择EPC
        // reader.selectEPC(Tools.HexString2Bytes(epc));

        Toast.makeText(getApplicationContext(), epc, Toast.LENGTH_SHORT).show();
        Intent intent = new Intent(this, MoreHandleActivity.class);
        intent.putExtra("epc", epc);
        startActivity(intent);
    }

    @Override
    public boolean onMenuItemSelected(int featureId, MenuItem item) {
        // Log.e("", "adfasdfasdf");
        Intent intent = new Intent(this, SettingActivity.class);
        startActivity(intent);
//		Intent intent = new Intent(this, SettingPower.class);
//		startActivity(intent);
        return super.onMenuItemSelected(featureId, item);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {

        getMenuInflater().inflate(R.menu.main, menu);

        return true;
    }

    @Override
    public boolean onMenuOpened(int featureId, Menu menu) {
        if (featureId == Window.FEATURE_ACTION_BAR && menu != null) {
            if (menu.getClass().getSimpleName().equals("MenuBuilder")) {
                try {
                    Method m = menu.getClass().getDeclaredMethod(
                            "setOptionalIconsVisible", Boolean.TYPE);
                    m.setAccessible(true);
                    m.invoke(menu, true);
                } catch (Exception e) {
                }
            }
        }
        return super.onMenuOpened(featureId, menu);
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        // TODO Auto-generated method stub
        if (keyCode == KeyEvent.KEYCODE_F1) {
            if (!startFlag) {
                startFlag = true;
                buttonStart.setText(R.string.stop_inventory);
            } else {
                startFlag = false;
                buttonStart.setText(R.string.inventory);
            }
        }
        return super.onKeyDown(keyCode, event);
    }

    /**
     * 打印信息接收
     *
     * @author wu
     */
    class GetMessageBroadcastReceiver extends BroadcastReceiver {
        @Override
        public void onReceive(Context context, Intent intent) {
            // TODO Auto-generated method stub
            int message = intent.getIntExtra("message", 0);
            switch (message) {
                case 0:
                    //print success
                    Toast.makeText(context, "打印成功", Toast.LENGTH_SHORT).show();
                    break;
                case 1:
                    //no paper
//                    Log.e("onReceive: ", "已保存，缺少打印纸");
                    Toast.makeText(context, "已保存，缺少打印纸", Toast.LENGTH_SHORT).show();
                    break;
                default:
                    break;
            }
        }
    }
}
